//--------------------------------------
// Phantom Cannon Launcher
// Made with help of S[H]A[D]O[W]
//--------------------------------------

datablock AudioProfile(PhantomBigboomSound)
{
   filename    = "fx/weapons/grenade_flash_explode.wav";
   description = AudioDefault3d;
   preload = true;
   effect = PhantomCannonBigboomEffect;
};

datablock AudioProfile(SCSwitchSound)
{
   filename    = "fx/Bonuses/Nouns/special2.wav";
   description = AudioDefault3d;
   preload = true;
   effect = PhantomCannonBigboomEffect;
};

datablock EffectProfile(PhantomCannonBigboomEffect)
{
   effectname = "weapons/Phantom_Explosion";
   minDistance = 700.0;
   maxDistance = 800.0;
};

datablock ParticleData( VehicleCrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
colors[0] = "0.850394 0.304000 0.192000 0.451613";
colors[1] = "0.000000 0.000000 0.000000 0.709677";
colors[2]     = "0.850394 0.304000 0.192000 0.451613";
sizes[0] = 42.0;
sizes[1] = 43.0;
sizes[2] = 44.5;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( VehicleCrescentEmitter )
{
ejectionPeriodMS = 25;
periodVarianceMS = 0;
ejectionVelocity = 70;
velocityVariance = 5.0;
ejectionOffset = 0.0;
thetaMin = 0;
thetaMax = 180;
phiReferenceVel = 0;
phiVariance = 360;
overrideAdvances = false;
orientParticles = true;
lifetimeMS = 20;
particles = "VehicleCrescentParticle";
};
datablock ParticleData(GrenadeRedSmokeParticle)
{
    dragCoeffiecient     = 0.3;
    gravityCoefficient   = -0.3;


    inheritedVelFactor = 0.0;
    constantAcceleration = 0;
    lifetimeMS = 4250; // was  1250
    lifetimeVarianceMS = 0;
    useInvAlpha = 0;
     spinRandomMin        = -90.0;
   spinRandomMax        = 500.0;
    textureName = "special/Smoke/bigSmoke";
    times[0] = 0;
    times[1] = 0.3;
    times[2] = 1;
    colors[0] = "1 0 1";
    colors[1] = "1 1 0";
    colors[2] = "1 0 0";
    sizes[0] = 0;
    sizes[1] = 6;
    sizes[2] = 9;
};

datablock ParticleEmitterData(GrenadeRedSmokeEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 2.25;
   velocityVariance = 0.55;

   thetaMin         = 0;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;

   particles = "GrenadeRedSmokeParticle";
};
datablock ShockwaveData(LargePhantomCannonShockwave)
{
   width = 32.5;
   numSegments = 20;
   numVertSegments = 8;
   velocity = 12;
   acceleration = 35.0;
   lifetimeMS = 4200;
   height = 35.0;
   verticalCurve = 0.5;

   mapToTerrain = false;
   renderBottom = true;

   texture[0] = "special/shockwave5";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.8 0.8 0.8 1.0";
   colors[1] = "0.8 0.5 0.2 0.6";
   colors[2] = "1.0 0.5 0.5 0.0";
};
datablock ParticleData(LargePhantomCannonExplosionSmoke)
{
   dragCoeffiecient     = 1;
   gravityCoefficient   = -0.25;
   inheritedVelFactor   = 0;

   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;

   useInvAlpha =  true;
   spinRandomMin = -100.0;
   spinRandomMax =  100.0;

   textureName = "special/Smoke/bigSmoke";

   colors[0] = "1 0 1";
   colors[1] = "1 .7 1";
   colors[2] = "1 0 0";

   sizes[0]      = 7.0;
   sizes[1]      = 9.0;
   sizes[2]      = 11.0;

   times[0]      = 0.0;
   times[1]      = 0.7;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(LargePhantomCannonExplosionSmokeEmitter)
{
   ejectionPeriodMS = 1.0;
   periodVarianceMS = 0.5;

   ejectionOffset = 0;

   ejectionVelocity = 15;
   velocityVariance = 5;

   thetaMin         = 0.0;
   thetaMax         = 180.0;

   lifetimeMS       = 1000;
   useEmitterSizes = false;
   particles = "LargePhantomCannonExplosionSmoke";

};

datablock ParticleData(LargePhantomCannonFire33Particle)
{
    dragCoeffiecient     = 0.0;
    gravityCoefficient   = 0.01;
    inheritedVelFactor   = 1.0;

    inheritedVelFactor = 0.025;
    constantAcceleration = 0;
    lifetimeMS = 4250; // was  1250
    lifetimeVarianceMS = 0;
    useInvAlpha = 0;
    spinRandomMin = -200;
    spinRandomMax = 200;
    textureName = "special/Smoke/smoke_001";
    times[0] = 0.0;
    times[1] = 0.3;
    times[2] = 1.0;
    colors[0] = "1 0 1";
    colors[1] = "1 0 1";
    colors[2] = "1 0 0";
    sizes[0] = 0;
    sizes[1] = 11;
    sizes[2] = 11;
};

datablock ParticleEmitterData(LargePhantomCannonFire33Emitter)
{
    ejectionPeriodMS = 5;
    periodVarianceMS = 0;
    ejectionVelocity = 7.25;
    velocityVariance = 0.25;
    ejectionOffset =   5;
    thetaMin = 0;
    thetaMax = 80;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
    orientParticles= 0;
    orientOnVelocity = 1;
    particles = "LargePhantomCannonFire33Particle";
};
//--------------------------------------------------------------
// PhantomCannonBombExplosion
//--------------------------------------------------------------

datablock ExplosionData(LargePhantomCannonBombExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   playSpeed = 0.05;   // was 0.25
   soundProfile = PhantomCannonBigboomEffect;
   faceViewer = true;
   sizes[0] = "25.0 25.0 25.0";
   sizes[1] = "50.0 50.0 50.0";
   times[0] = 0.0;
   times[1] = 1.0;
   emitter[0] = PhantomCannonDustEmitter;
   emitter[1] = LargePhantomCannonExplosionSmokeEmitter;
   emitter[2] = VehicleCrescentEmitter;
   shockwave = LargePhantomCannonShockwave;

   //debris = FireballAtmosphereDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 60;
   debrisNum = 10;
   debrisNumVariance = 5;
   debrisVelocity = 20.0;
   debrisVelocityVariance = 5.0;

   subExplosion = VLGSpikeExplosion;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "140.0 140.0 140.0";
   camShakeDuration = 1.3;
   camShakeRadius = 330.0;
};

//--------------------------------------------------------------------------
// PhantomCannonBomb Third Explosion
//--------------------------------------------------------------------------

datablock ExplosionData(LargePhantomCannonBomb3Explosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   playSpeed = 0.05; // was 0.25
   soundProfile = PhantomCannonBigboomEffect;
   particleEmitter = PlasmaExplosionEmitter;
   particleDensity = 150;
   particleRadius = 1.25;
   faceViewer = true;

   sizes[0] = "24 24 24";
   sizes[1] = "34 34 34";
   times[0] = 0.0;
   times[1] = 1.0;

   emitter[0] = LargePhantomCannonExplosionSmokeEmitter;
   emitter[1] = VehicleCrescentEmitter;
   shockwave = LargePhantomCannonShockwave;

   debris = FireballAtmosphereDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 60;
   debrisNum = 10;
   debrisNumVariance = 5;
   debrisVelocity = 30.0;
   debrisVelocityVariance = 5.0;

   subExplosion = VLGSpikeExplosion;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "140.0 140.0 140.0";
   camShakeDuration = 1.3;
   camShakeRadius = 330.0;


};

//--------------------------------------------------------------------------
// PhantomCannonBomb Fourth Explosion
//--------------------------------------------------------------------------

datablock ExplosionData(LargePhantomCannonBomb4Explosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   playSpeed = 0.05; // was 0.25
   //soundProfile = BombExplosionSound;
   particleEmitter = PlasmaExplosionEmitter;
   particleDensity = 150;
   particleRadius = 1.25;
   faceViewer = true;

   sizes[0] = "12 12 12";
   sizes[1] = "24 24 24";
   times[0] = 0.0;
   times[1] = 1.0;

   emitter[0] = LargePhantomCannonExplosionSmokeEmitter;
   emitter[1] = VehicleCrescentEmitter;
   //shockwave = VehicleShockwave;

   debris = FireballAtmosphereDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 60;
   debrisNum = 10;
   debrisNumVariance = 5;
   debrisVelocity = 20.0;
   debrisVelocityVariance = 5.0;

  subExplosion = VLGSpikeExplosion;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "140.0 140.0 140.0";
   camShakeDuration = 1.3;
   camShakeRadius = 330.0;


};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------

datablock GrenadeProjectileData(LargePhantomCannonShot)   // this is the main bomb
{
   projectileShapeName = "weapon_missile_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;

   hasDamageRadius     = true;
   indirectDamage      = 6.0;

   damageRadius        = 100.0;
   radiusDamageType    = $DamageType::NukeWind;
   kickBackStrength    = 35000;

   explosion           = "LargePhantomCannonBombExplosion";
   underwaterExplosion = "UnderwaterMortarExplosion";
   splash              = MortarSplash;
   velInheritFactor    = 0.5;
   depthTolerance      = 15.0;

   baseEmitter         = MortarSmokeEmitter;
   bubbleEmitter       = MortarBubbleEmitter;

   grenadeElasticity = 0.15;
   grenadeFriction   = 0.4;
   armingDelayMS     = 0;
   muzzleVelocity    = 63.7;
   drag              = 0.1;

   sound			 = MortarProjectileSound;

   hasLight    = true;
   expProj     = "LargePhantomCannonBomb2";
   mortarCount = 2;

   lightRadius = 4;
   lightColor  = "1.0 0.5 0.0";

   hasLightUnderwaterColor = true;
   underWaterLightColor = "0.9 0.5 0.0";

};

//------------------PhantomCannon Projectile that fires up (Second Blast)-------------------------------------------------

datablock LinearProjectileData(LargePhantomCannonBomb2)
{
   projectileShapeName = "disc.dts";
   emitterDelay        = -1;
   directDamage        = 0;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   radiusDamageType    = $DamageType::NukeWind;
   kickBackStrength    = 100;
   bubbleEmitTime      = 1.0;

   sound               = GrenadeProjectileSound;
   explosion           = "LargePhantomCannonBomb3Explosion";
   underwaterExplosion = "UnderwaterGrenadeExplosion";
   velInheritFactor    = 0.5;
   splash              = GrenadeSplash;

   baseEmitter         = LargePhantomCannonFire33Emitter;
   //baseEmitter         = GrenadeRedSmokeEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;

   dryVelocity       = 45; // was 75
   wetVelocity       = 25;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   activateDelayMS = 200;

   expProj     = "LargePhantomCannonBurstFrags";
   mortarCount = 2;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.175 0.175 0.5";
};

//------------------PhantomCannon Burst In Air + Fragments-------------------------------------------------

datablock LinearProjectileData(LargePhantomCannonBurstFrags)
{
   projectileShapeName = "disc.dts";
   emitterDelay        = -1;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.1;
   damageRadius        = 100.0;
   radiusDamageType    = $DamageType::NukeWind;
   kickBackStrength    = 100;
   bubbleEmitTime      = 1.0;

   sound               = GrenadeProjectileSound;
   explosion           = "LargePhantomCannonBomb4Explosion";
   underwaterExplosion = "UnderwaterGrenadeExplosion";
   velInheritFactor    = 0.5;
   splash              = GrenadeSplash;

   //baseEmitter         = LargePhantomCannonFire33Emitter;
   //baseEmitter         = GrenadeRedSmokeEmitter;
   //bubbleEmitter       = GrenadeBubbleEmitter;

   dryVelocity       = 55; // was 75
   wetVelocity       = 25;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 300;
   lifetimeMS        = 300;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   activateDelayMS = 200;

   //expProj     = "LargePhantomCannonBurstFrags2";
   mortarCount = 1;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.175 0.175 0.5";
};

datablock LinearProjectileData(LargePhantomCannonBurstFrags2)
{
   projectileShapeName = "disc.dts";
   emitterDelay        = -1;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 6.50;
   damageRadius        = 100.0;
   radiusDamageType    = $DamageType::NukeWind;
   kickBackStrength    = 100;
   bubbleEmitTime      = 1.0;

   sound               = GrenadeProjectileSound;
   explosion           = "LargePhantomCannonBomb4Explosion";
   underwaterExplosion = "UnderwaterGrenadeExplosion";
   velInheritFactor    = 0.5;
   splash              = GrenadeSplash;

   //baseEmitter         = LargePhantomCannonFire33Emitter;
   //baseEmitter         = GrenadeRedSmokeEmitter;
   //bubbleEmitter       = GrenadeBubbleEmitter;

   dryVelocity       = 45; // was 75
   wetVelocity       = 25;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   activateDelayMS = 200;

};

/////////////////////////////////////////////////////////////////////////////

//******************************************************************************
// Large PhantomCannon Shot::onExplode
//******************************************************************************
function LargePhantomCannonShot::onExplode(%data, %proj, %pos, %mod)
{
     Parent::onExplode(%data, %proj, %pos, %mod);
     
     for(%r = 0; %r < 50; %r++)
     {
     %timeme = %r * 450;
     schedule(%timeme,0,"PCRadiationEffect");   //goodie
     }

     for(%i = 0; %i < 2; %i++)
     {
      //%x = getRandom() - 0.5;
      //%y = getRandom() - 0.5;
      //%vec = %x SPC %y SPC 1.0; //Shoot up
      %p = new LinearProjectile()
      {
       dataBlock        = %data.expProj;
       initialDirection = "0 0 1";
       initialPosition  = %pos;
       parent = %proj;
      owner = %proj;
      vehicleObject    = 0;
      };

      if (isObject(%proj.lastProjectile) && %proj.deleteLastProjectile)
      %proj.lastProjectile.delete();

   %proj.lastProjectile = %p;
   %proj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%proj.client)
      %proj.client.projectile = %p;
            %x = new LinearProjectile()
      {
         dataBlock        = "LargePhantomCannonBurstFrags2";
         initialDirection = "0 0 1";
         initialPosition  = %pos;
         sourceObject     = %proj.sourceObject;
         sourceSlot       = 0;
         vehicleObject    = 0;
      };

         if (isObject(%proj.lastProjectile) && %proj.deleteLastProjectile)
      %proj.lastProjectile.delete();

   %proj.lastProjectile = %x;
   %proj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%x);

   // AI hook
   if(%proj.client)
      %proj.client.projectile = %x;

     }
        InitContainerRadiusSearch(%pos, 400.0, $TypeMasks::PlayerObjectType |
                                          $TypeMasks::TurretObjectType);

   while ((%flashObj = containerSearchNext()) != 0)
   {
   %dist = containerSearchCurrDist();
   %eyeXF = %flashObj.getEyeTransform();
   %epX   = firstword(%eyeXF);
   %epY   = getWord(%eyeXF, 1);
   %epZ   = getWord(%eyeXF, 2);
   %eyePos = %epX @ " " @ %epY @ " " @ %epZ;
   %eyeVec = %flashObj.getEyeVector();

   // Make sure we can see the thing...
   if (ContainerRayCast(%eyePos, %pos, $TypeMasks::TerrainObjectType |
   $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType, %flashObj) !$= "0")
   {
     continue;
   }

   %flashObj.setWhiteOut(0.75);
   }
return %x;
}

///////////PhantomCannonBombVerticalPro::onExplode////////////////////////////////////////////////////////////

function LargePhantomCannonBomb2::onExplode(%data, %proj, %pos, %mod)
{
     Parent::onExplode(%data, %proj, %pos, %mod);
     for(%i = 0; %i < 2; %i++)
     {
      %p = new LinearProjectile()
      {
         //dataBlock        = %projectile;
         dataBlock        = "LargePhantomCannonBurstFrags";
         initialDirection = "0 0 -1";
         initialPosition  = %pos;
         sourceObject     = %proj.sourceObject;
         sourceSlot       = -1;
         vehicleObject    = 0;
      };

   if (isObject(%proj.lastProjectile) && %proj.deleteLastProjectile)
      %proj.lastProjectile.delete();

   %proj.lastProjectile = %p;
   %proj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);
   
   SkyNuked();
   schedule(20000,0, skyMorningPC);
   // AI hook
   if(%proj.client)
      %proj.client.projectile = %p;
     }
        InitContainerRadiusSearch(%pos, 400.0, $TypeMasks::PlayerObjectType |
                                          $TypeMasks::TurretObjectType);

   while ((%flashObj = containerSearchNext()) != 0)
   {
   %eyeXF = %flashObj.getEyeTransform();
   %epX   = firstword(%eyeXF);
   %epY   = getWord(%eyeXF, 1);
   %epZ   = getWord(%eyeXF, 2);
   %eyePos = %epX @ " " @ %epY @ " " @ %epZ;
   %eyeVec = %flashObj.getEyeVector();

   // Make sure we can see the thing...
   if (ContainerRayCast(%eyePos, %pos, $TypeMasks::TerrainObjectType |
   $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType, %flashObj) !$= "0")
   {
     continue;
   }

   %flashObj.setWhiteOut(0.75);
   }
return %p;
}


//////////////PhantomCannonBurstFrags/////////////////////////////////////////

function LargePhantomCannonBurstFrags::onExplode(%data, %proj, %pos, %mod)
{
     Parent::onExplode(%data, %proj, %pos, %mod);

        InitContainerRadiusSearch(%pos, 400.0, $TypeMasks::PlayerObjectType |
                                          $TypeMasks::TurretObjectType);

   while ((%flashObj = containerSearchNext()) != 0)
   {
   %eyeXF = %flashObj.getEyeTransform();
   %epX   = firstword(%eyeXF);
   %epY   = getWord(%eyeXF, 1);
   %epZ   = getWord(%eyeXF, 2);
   %eyePos = %epX @ " " @ %epY @ " " @ %epZ;
   %eyeVec = %flashObj.getEyeVector();

   // Make sure we can see the thing...
   if (ContainerRayCast(%eyePos, %pos, $TypeMasks::TerrainObjectType |
   $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType, %flashObj) !$= "0")
   {
     continue;
   }

   %flashObj.setWhiteOut(0.5);
   }
}


///END

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(PhantomCannon)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = PhantomCannonImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a PhantomCannon Laucher";
    emap = true;
};

datablock ShapeBaseImageData(PhantomCannonImage)
{
   className = WeaponImage;
   shapeFile = "turret_mortar_large.dts";
   item = PhantomCannon;
//   ammo = PhantomCannonAmmo;
   offset = "0 0 0";
   emap = true;
   usesEnergy = true;

   projectile = LargePhantomCannonShot;
   projectileType = GrenadeProjectile;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = SCSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Charge";
   stateTransitionOnNoAmmo[1] = "NoAmmo";
   stateTransitionOnTimeout[1] = "NoAmmo";
   stateTimeoutValue[1] = 0.1;


   stateName[2] = "Charge";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTimeout[2] = "Ready";
   stateTimeoutValue[2] = 0.1;
   stateScript[2] = "onCharge";
   stateTransitionOnTriggerDown[2] = "DryFire";

   stateName[3] = "Ready";
   stateTransitionOnNoAmmo[3] = "NoAmmo";
   stateTransitionOnTriggerDown[3] = "Fire";
   stateSequence[3]         = "Deploy";

   stateName[4] = "Fire";
   stateTransitionOnTimeout[4] = "Reload";
   stateTimeoutValue[4] = 0.1;
   stateFire[4] = true;
   stateRecoil[4] = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4] = "onFire";
   stateEmitterTime[4] = 0.2;
   stateSound[4] = AssaultMortarFireSound;

   stateName[5] = "Reload";
   stateTransitionOnNoAmmo[5] = "NoAmmo";
   stateTransitionOnTimeout[5] = "Ready";
   stateTimeoutValue[5] = 0.6;
   stateAllowImageChange[5] = false;
   stateSequence[5] = "Reload";
   stateSound[5] = MortarReloadSound;

   stateName[6] = "NoAmmo";
   stateTransitionOnAmmo[6] = "Reload";
   stateSequence[6] = "NoAmmo";
   stateTransitionOnTriggerDown[6] = "DryFire";

   stateName[7]       = "DryFire";
   stateSound[7]      = MortarDryFireSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "NoAmmo";
};
datablock ShapeBaseImageData(PhantomCannonRifleImage2)
{
   shapeFile = "pack_upgrade_sensorjammer.dts";
   offset = "-0.08 0.30 0.16";
   rotation = "1 0 0 90";
   emap = true;

};
function PhantomCannonImage::onMount(%this,%obj,%slot)
{
    Parent::onMount(%this, %obj, %slot);
    commandToClient( %obj.client, 'BottomPrint', "<spush><font:Tempus Sans ITC:22><color:ff3300>Phantom Cannon V2.0<spop>", 5, 2);
    %obj.mountImage(PhantomCannonRifleImage2,4);
    %obj.client.setWeaponsHudActive("Mortar");

}

function PhantomCannonImage::onUnmount(%this,%obj,%slot)
{
   %obj.unmountImage(4);
   %obj.setImageTrigger(%slot, false);
   Parent::onUnmount(%this, %obj, %slot);
}

function PhantomCannonImage::onFire(%data,%obj,%slot) // ADDED HERE
{
   if(%obj.client.Pcannoned) {
   commandToClient( %obj.client, 'BottomPrint', "<spush><font:Tempus Sans ITC:22><color:ff3300>Phantom Cannon is still recharging<spop>", 5, 2);
   return;
   }
   %p = Parent::onFire(%data, %obj, %slot);
   schedule(30000,0,ResetPhantomCannon,%obj.client);
   %obj.client.Pcannoned = 1;
    messageAll('MsgPhantomCannonDoom', "\c2All Wrath of "@%obj.client.namebase@" Will Be felt, Phantom Cannon Strike Inbound!!!~wvoice/derm1/gbl.woohoo.wav");
}

function ResetPhantomCannon(%client) {
%client.Pcannoned = 0;
commandToClient(%client, 'BottomPrint', "<spush><font:Tempus Sans ITC:22><color:ff3300>Phantom Cannon Recharged<spop>", 5, 2);
}

//Reset
function skyMorningPC()
{
    Precipitation.delete();
	Sky.delete();
	new Sky(Sky)
		{
		position = "-1024 -1584 0";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		cloudHeightPer[0] = "0.349971";
		cloudHeightPer[1] = "0.25";
		cloudHeightPer[2] = "0.199973";
		cloudSpeed1 = "0.0001";
		cloudSpeed2 = "0.0002";
		cloudSpeed3 = "0.0003";
		visibleDistance = "600";
		useSkyTextures = "1";
		renderBottomTexture = "0";
		SkySolidColor = "0.000000 0.000000 0.000000 0.000000";
		fogDistance = "450";
		fogColor = "0.6 0.6 0.7 1";
		fogVolume1 = "0 0 0";
		fogVolume2 = "0 0 0";
		fogVolume3 = "0 0 0";
		materialList = "sky_lush_blue.dml";
		windVelocity = "0 0 0";
		windEffectPrecipitation = "0";
		fogVolumeColor1 = "128.000000 128.000000 128.000000 1";
		fogVolumeColor2 = "128.000000 128.000000 128.000000 0.000000";
		fogVolumeColor3 = "128.000000 128.000000 128.000000 0.000000";
		cloudSpeed0 = "0.000000 0.000000";
};
}

function SkyNuked()
{
    Sky.delete();
	new Sky(Sky) {
		position = "0 0 0";
		rotation = "1 0 0 0";
		scale = "1 1 1";
		cloudHeightPer[0] = "0.349971";
		cloudHeightPer[1] = "0.25";
		cloudHeightPer[2] = "0.199973";
		cloudSpeed1 = "0.0001";
		cloudSpeed2 = "0.0002";
		cloudSpeed3 = "0.0003";
    	visibleDistance = "800";
		useSkyTextures = "0";
		renderBottomTexture = "0";
		SkySolidColor = "1.000000 0.000000 0.000000 0.000000";
		materialList = "sky_badlands_cloudy.dml";
		windVelocity = "1 0 0";
		windEffectPrecipitation = "0";
		high_visibleDistance = "-1";
    	cloudSpeed0 = "0.000503 0.000020";
     };
     
   //Ash Effect
   %Ash = new Precipitation() {
      position = "0 0 0";
      rotation = "1 0 0 0";
      scale = "1 1 1";
      dataBlock = "Snow";
      percentage = "1";
      color1 = "0.3 0.3 0.3 1";
      color2 = "0.3 0.3 0.3 1";
      color3 = "0.3 0.3 0.3 1";
      offsetSpeed = "0.25";
      minVelocity = "0.25";
      maxVelocity = "1.5";
      maxNumDrops = "2000";
      maxRadius = "125";
         locked = "true";
   };
   MissionCleanup.add(%Ash);
}

function PCRadiationEffect() {
%count = ClientGroup.getCount();
for (%i = 0; %i < %count; %i++)
{
%cl = ClientGroup.getObject( %i );
if (isobject(%cl.player)) {
%cl.player.damage(0, %cl.player.position, 0.05, $DamageType::Radiation);
%cl.player.setWhiteOut(15 * 0.05);
}
}
}
